/*
 * Copyright(C) 2007  
 *
 *    , 
 *    .
 *
 *        ,
 * ,    ,
 *     ,
 * ,      
 *     
 *      .
 */

/*!
 * \file $RCSfile$
 * \version $Revision: 138920 $
 * \date $Date:: 2016-05-25 16:43:07 +0300#$
 * \author $Author: dim $
 * \brief     .
 */

#include "fat12prj.h"

DWORD fat12_info_name( 
    TSupSysContext *context, TSupSysInfo *info )
{
    TSupSysInfoText *inf = (TSupSysInfoText*)info;
    TFat12Context *ctx = (TFat12Context*)context;
    DWORD code;
    size_t res_len;
    SUPSYS_PRE_INFO( info, TSupSysInfoText );
    SUPSYS_PRE_CCONTEXT( context, TFat12Context );
    if(inf->length)
	SUPSYS_PRE_WRITE_PTRS(inf->text, (inf->length+1) * sizeof(TCHAR));

    res_len = inf->length;
    code = support_resource_string(FAT12_RESOURCE, IDS_FAT12_NAME, inf->text, &res_len);
    if( code )
	return code;

    if(inf->length)
    {
	if(inf->length > res_len)
	    inf->text[res_len] = _TEXT(' ');
	if(inf->length > res_len + 1)
 	    _tcsncpy(inf->text + res_len + 1, ctx->connect, inf->length - res_len - 1);
	inf->text[inf->length] = 0;
    }
    inf->length = res_len + 1 + _tcslen(ctx->connect);
    return ERROR_SUCCESS;
}
