/*
 * Copyright(C) 2000  
 *
 *    , 
 *    .
 *
 *        ,
 * ,    ,
 *     ,
 * ,      
 *     
 *      .
 */

/*!
 * \file $RCSfile$
 * \version $Revision: 127051 $
 * \date $Date:: 2015-09-09 15:08:20 +0300#$
 * \author $Author: pav $
 * \brief   DS19xx.
 */

#if !defined( _READER_DS_DS_CTX_H )
#define _READER_DS_DS_CTX_H

#include "reader.kit/reader.h"

#define DALLAS_FUN_IS_SAME_SER_NUM 0x2500

#if defined( __cplusplus )
extern "C" {
#endif
  
typedef DWORD (*DSReadFun)( TSupSysContext *context, size_t from, 
    size_t *length, unsigned char *buffer );

typedef DWORD (*DSWriteFun)( TSupSysContext *context, size_t from, 
    size_t *length, const unsigned char *buffer );

typedef struct TDSInfoIsSame_
{
    unsigned char unique[8];
} TDSInfoIsSame;

typedef struct TDSInfoConnectCarrier_
{
    unsigned char unique[8];
    TSupSysContext *context;
    DSReadFun read_proc;
    DSWriteFun write_proc;
    unsigned flags;
} TDSInfoConnectCarrier;

typedef struct TDSInfoUnique_
{
    unsigned char unique[8];
    TSupSysInfoText unique_str;
} TDSInfoUnique;

#if defined( __cplusplus )
}
#endif

#endif /* !_READER_DS_DS_H */
